Program AllRegs;  { uwe.sieber@gmx.de }
uses dos,PCIunit,base_n;

var func,revision: byte;

var res:byte;
var b: byte;
var i:integer;
var dev, ven, busdev: word;

function GetRegByte(busdev: word; reg: word): byte;
begin
	asm
		mov ax, 0b108h  { read byte }
		mov bx, busdev
		mov di, reg
		int 1ah
		mov b, cl
	end;
	GetRegByte:=b;
end;


begin

if paramcount=0 then begin
	busdev:=0;
end;

if paramcount=2 then begin
	dev:=hextoword(paramstr(1));
	ven:=hextoword(paramstr(2));
	asm
		mov ax, 0b102h {find pci device}
		mov cx, dev
		mov dx, ven
		mov si, 0
		int 1ah
		
		mov busdev, bx
		
		mov b, 0
		jc @notFound
		mov b, 1
		@notFound:
	end;
	
	if b=0 then begin
		writeln('Device ', wordTohex(dev), 'h of Vendor ', wordToHex(ven), 'h NOT found');
		halt(1);
	end;
end;

{directvideo:=false;}
for i:=1 to 255 do begin
	res:=GetRegByte(busdev, i);
	writeln (ByteToHex(i), ', ', byteToHex(res), ' = ', ByteToBin(res));
end;

end.
